////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	avDebug.h
// Desc:	Some debugging functionality used during development
////////////////////////////////////////////////////////////////////////////////

//-----------------------------------------------------------------------------
// Include directives

#include "antivirus.h"


//-----------------------------------------------------------------------------
// Macro definitions

//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data definitions

sChar8 	gDebugOutput[512];
sChar8	gDebugMsgBuffer[512];


//-----------------------------------------------------------------------------
// Static data definitions

//-----------------------------------------------------------------------------
// Forward declaration of functions

//-----------------------------------------------------------------------------
// Function definitions

////////////////////////////////////////////////////////////////////////////////
// PUBLIC assertWithMsg
//
// check a conditional, stop program execution and display an error message if failed

void assertWithMsg(
	sBool cond,
	sChar8 *fmt, 
	...)
{
	va_list		arglist;

	if (!cond)
	{
		// process variable argument list into formatted string
		va_start (arglist, fmt);
		vsprintf ((sChar8 *)gDebugMsgBuffer, (sChar8 *)fmt, (sChar8 *)arglist);
		va_end (arglist);

		// create debug output message
		sprintf(gDebugOutput,
			"FATAL ERROR:\n\n%s\n",gDebugMsgBuffer);

		// show user and quit
		MessageBox(NULL, gDebugOutput, "Antivirus", MB_OK|MB_ICONWARNING);
		exit(-1);
	}
}

