////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	avGameDefs.h
// Desc:	Any central definitions that need global inclusion
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_AVGAMEDEFS_H
#define HDD_ANTIVIRUS_CORE_AVGAMEDEFS_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

#define RANDOM( a ) ( ( (sFloat32)rand()/(sFloat32)RAND_MAX)*(a) )
#define IRANDOM( a ) ( (sInt32)( (sFloat32)rand()/(sFloat32)RAND_MAX)*(a) )


//-----------------------------------------------------------------------------
// Enumerations

////////////////////////////////////////////////////////////////////////////////
// ENUM eGameDifficulty
//
// which difficulty level has been selected

typedef enum eGameDifficulty
{
	GD_AV_EASY,					// Bacterial Banisher
	GD_AV_NORMAL,				// Viral Vanquisher
	GD_AV_HARD,					// DNA Dominator
	GD_AV_NASTY,				// Chemical Conqueror

	NUM_GAME_DIFF_SETTINGS

} eGameDifficulty;


//-----------------------------------------------------------------------------
// Type definitions

//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_AVGAMEDEFS_H
