////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	c2DRender.h
// Desc:	Bits and pieces required to support 2D-style rendering
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_C2DRENDER_H
#define HDD_ANTIVIRUS_CORE_C2DRENDER_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

////////////////////////////////////////////////////////////////////////////////
// CLASS c2DRender
//
// Provides a system to apply a 2D projection matrix to a viewport

class c2DRender
{
public:
	//-------------------------------------------------------------
	// Public data

	//-------------------------------------------------------------
	// Public functions

	////////////////////////////////////////////////////////////////////////////////
	// STATIC METHOD applyViewMatrix
	//
	// apply a 2D projection matrix to the given view

	static void applyViewMatrix(
		c3DGameView *gview);


	// constructor
	c2DRender (void);

};


//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_C2DRENDER_H
