////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	c3DRender.h
// Desc:	A place to store the setup for the main 3D rendered scene
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_C3DRENDER_H
#define HDD_ANTIVIRUS_CORE_C3DRENDER_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

class c3DGameView;

////////////////////////////////////////////////////////////////////////////////
// CLASS c3DRender
//
// Provides a system to apply a 3D projection matrix to a viewport

class c3DRender
{
private:
	//-------------------------------------------------------------
	// Private data

	//-------------------------------------------------------------
	// Private functions


protected:
	//-------------------------------------------------------------
	// Protected data

	D3DXMATRIX			mViewMtx, mProjMtx;			// cached matrices


	//-------------------------------------------------------------
	// Protected functions


public:
	//-------------------------------------------------------------
	// Public data

	//-------------------------------------------------------------
	// Public functions

	////////////////////////////////////////////////////////////////////////////////
	// METHOD init
	//
	// initialise the class to defaults, ready for use

	void init(void);

	////////////////////////////////////////////////////////////////////////////////
	// STATIC METHOD applyViewMatrix
	//
	// apply a 3D projection matrix to the given view

	void applyViewMatrix(
		c3DGameView *gview);


	// constructor
	c3DRender (void);

};


//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_C3DRENDER_H
