////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	cCureData.h
// Desc:	Definitions for all cure data, colour and meshes, etc
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_CCUREDATA_H
#define HDD_ANTIVIRUS_CORE_CCUREDATA_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

class cCureChain;

////////////////////////////////////////////////////////////////////////////////
// CLASS cCureData
//
// Container class managing the data for drawing cure blocks

class cCureData
{
private:
	//-------------------------------------------------------------
	// Private data

	//-------------------------------------------------------------
	// Private functions


protected:
	//-------------------------------------------------------------
	// Protected data

	ID3DXBuffer		*mMtlBuffer;
	ID3DXMesh		*mMesh;


	//-------------------------------------------------------------
	// Protected functions


public:
	//-------------------------------------------------------------
	// Public data

	//-------------------------------------------------------------
	// Public functions

	////////////////////////////////////////////////////////////////////////////////
	// METHOD renderCureBlock
	//
	// renders a cure block, does not set world TM

	void renderCureBlock(
		sFloat32 valpha,		// alpha value for this component
		eViralCode	vcode,		// one of the registered viral codes
		cCureChain *cc);		// chain data

	////////////////////////////////////////////////////////////////////////////////
	// METHOD init
	//
	// initialise the class to defaults, ready for use

	void init(void);


	// constructor
	cCureData (void);

};


//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_CCUREDATA_H
