////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	cCureSeq.h
// Desc:	The helper object showing current the cure sequence
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_CCURESEQ_H
#define HDD_ANTIVIRUS_CORE_CCURESEQ_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

////////////////////////////////////////////////////////////////////////////////
// CLASS cCureSeq
//
// A cure sequence is the object floating over the mouse cursor showing which
// viral chain is constructed

class cCureSeq
{
public:
	//-------------------------------------------------------------
	// Public data

	D3DXMATRIX			mTM;						// current position, from mouse pos

	sInt32				mNumViralCodes;				// number of codes for this cure sequence
	eViralCode			mViralCodes[gMaxNumViralCodeList];				// list of viral codes

	sInt32				mLatDiv;					// number of pixels per lateral slot


	//-------------------------------------------------------------
	// Public functions

	////////////////////////////////////////////////////////////////////////////////
	// METHOD init
	//
	// initialise the class to defaults, ready for use

	void init(void);

	////////////////////////////////////////////////////////////////////////////////
	// METHOD update
	//
	// called via game loop, once per frame. updates class for the current frame.

	void update(
		cGameplay *gplay);

	////////////////////////////////////////////////////////////////////////////////
	// METHOD draw
	//
	// renders any graphics associated with this class (HUD, debug, etc)

	void draw(
		c3DGameView *gview);


	// constructor
	cCureSeq (void);

};


//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_CCURESEQ_H
