////////////////////////////////////////////////////////////////////////////////
// Copyright  2002 Harry Denholm
//
// Created for Ludum Dare 48Hr Coding Competition, July 2002 [www.ludumdare.com]
// Released free to the public, but use at your own risk!
//
// Family:	Antivirus Core
// File:	cMousePtr.h
// Desc:	A mouse pointer graphic
////////////////////////////////////////////////////////////////////////////////

#ifndef HDD_ANTIVIRUS_CORE_CMOUSEPTR_H
#define HDD_ANTIVIRUS_CORE_CMOUSEPTR_H


//-----------------------------------------------------------------------------
// Include directives

//-----------------------------------------------------------------------------
// Macro definitions

#define D3DFVF_MOUSEPTR_VERTEX (D3DFVF_XYZ|D3DFVF_TEX1)


//-----------------------------------------------------------------------------
// Enumerations

//-----------------------------------------------------------------------------
// Type definitions

////////////////////////////////////////////////////////////////////////////////
// STRUCT sMousePtrVtx
//
// the format for the flat panel mouse pointer

typedef struct sMousePtrVtx
{
    D3DXVECTOR3		mPos;
    sFloat32		mU, mV;

} sMousePtrVtx;


////////////////////////////////////////////////////////////////////////////////
// CLASS cMousePtr
//
// ** TODO: Description of class functionality ** 

class cMousePtr
{
private:
	//-------------------------------------------------------------
	// Private data

	//-------------------------------------------------------------
	// Private functions


protected:
	//-------------------------------------------------------------
	// Protected data

	// geometry storage buffers
	IDirect3DVertexBuffer8		*mVertexBuffer;

	IDirect3DTexture8			*mMousePtrTex;	// texture to use with mouse pointer

	//-------------------------------------------------------------
	// Protected functions


public:
	//-------------------------------------------------------------
	// Public data
	sInt32						mX, mY;			// mouse draw position, clamped inside screen

	//-------------------------------------------------------------
	// Public functions

	////////////////////////////////////////////////////////////////////////////////
	// METHOD init
	//
	// initialise the class to defaults, ready for use

	void init(void);

	////////////////////////////////////////////////////////////////////////////////
	// METHOD update
	//
	// called via game loop, once per frame. updates class for the current frame.

	void update(void);

	////////////////////////////////////////////////////////////////////////////////
	// METHOD draw
	//
	// renders any graphics associated with this class (HUD, debug, etc)

	void draw(void);

	////////////////////////////////////////////////////////////////////////////////
	// METHOD tidyup
	//
	// releases any memory, returns to defaults, shutsdown the class after use

	void tidyup(void);


	// constructor
	cMousePtr (void);

};


//-----------------------------------------------------------------------------
// Constants

//-----------------------------------------------------------------------------
// Global data declarations

//------------------------------------------------------------------------------
// Global function declarations



#endif // HDD_ANTIVIRUS_CORE_CMOUSEPTR_H
